cmake_minimum_required (VERSION 3.15)
# macro used for older CMAKE versions
macro(use_cxx11)
   if (CMAKE_VERSION VERSION_LESS "3.4")
   if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
   set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=gnu++11 -pthread")
   endif ()
   else ()
   set (CMAKE_CXX_STANDARD 11)
   endif ()
endmacro(use_cxx11)

macro(use_cxx17)
   if (CMAKE_VERSION VERSION_LESS "3.4")
   if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
   set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=gnu++17 -pthread")
   endif ()
   else ()
   set (CMAKE_CXX_STANDARD 17)
   endif ()
endmacro(use_cxx17)

set(DAQENV FALSE)
set(STANDALONE TRUE)
if ("${CMAKE_PROJECT_NAME}" STREQUAL "daqling_top")
  message( STATUS "Running in FASER DAQ environment.")
  set(STANDALONE FALSE)
  set(DAQENV TRUE)
elseif("${CMAKE_PROJECT_NAME}" STREQUAL "TrackerCalibration")
  message( STATUS "Running in tcalib environment.")
  set(STANDALONE FALSE)
else()
  message( STATUS "Running in STANDALONE.")
endif()

project (GPIODrivers)

use_cxx17()
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

#set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-error=old-style-cast -Wno-zero-as-null-pointer-constant -Wno-undef -Wno-sign-conversion -Wno-old-style-cast -Wno-strict-overflow")

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-zero-as-null-pointer-constant -Wno-undef -Wno-sign-conversion -Wno-old-style-cast -Wno-strict-overflow")

#Temporary solution to make gpiodrivers compile within FASER DAQ! Maybe even some unnecessary options. 
#add_compile_options( -fPIC -w -Wno-error=unused-but-set-variable -Wno-error=unused-variable -Wno-error=old-style-cast -Wno-error=unused-parameter -Wno-error=sign-conversion -Wno-error=conversion-null -Wno-error=sign-compare -Wno-error=pedantic -Wno-error=strict-overflow -Wno-error=parentheses -Wno-error=missing-declarations -Wno-error=overflow -Wno-error=unused-parameter -Wno-error=cast-qual)
#add_compile_options( -Wno-error -Wno-unused-variable -Wno-sign-compare -Wno-cast-function-type)
#These are for muparser...
add_compile_options( -Wno-cast-function-type -Wno-missing-declarations)

if (APPLE)
	message("Building for macOSX (${CMAKE_SYSTEM_NAME})")
elseif(UNIX)
	message("Building for UNIX (${CMAKE_SYSTEM_NAME})") 
endif()

if(DAQENV EQUAL TRUE)
  target_link_libraries(GPIODrivers PUBLIC ers)
endif()

if(DEFINED ENV{THIRD_PARTY_DIRECTORIES} AND NOT "$ENV{THIRD_PARTY_DIRECTORIES}" STREQUAL "")
  set(third_party_directories $ENV{THIRD_PARTY_DIRECTORIES})
  message("Including third party dependencies in ${third_party_directories}")
  include_directories(SYSTEM ${third_party_directories} )
endif()

add_subdirectory(GPIOBase)
add_subdirectory(TLBAccess)
add_subdirectory(TRBAccess/src)
add_subdirectory(muparser)
if (NOT DAQENV OR STANDALONE)
  add_subdirectory(faser-common)
endif()
if (STANDALONE)
  add_subdirectory(GPIOBase/src/app)
  add_subdirectory(TLBAccess/src/app)
  add_subdirectory(TRBAccess/src/app)
endif()

